#include <stdint.h>
#include <stdio.h>
#include <string.h>

uint16_t crc16(uint8_t* data, uint8_t length) {
    uint16_t crc = 0;
    while (length--) {
        crc ^= (uint16_t)(*data++ << 8);
        for (uint8_t i = 0; i < 8; i++) {
            if (crc & 0x8000) {
                crc = (uint16_t)(crc << 1u) ^ 0xA2EB;
            } else {
                crc <<= 1u;
            }
        }
    }
    return crc;
}


void main(int argc, char *argv[]) {
    uint8_t* text = "123456789";
    uint16_t crc = crc16(text, strlen(text));
    printf("Hello 0x%02X\n", crc);
}
